/* $Id: console.h,v 1.6 2010-08-21 21:59:15 simimeie Exp $
 * Functions for a serial console.
 */

#ifndef _CONSOLE_H_
#define _CONSOLE_H_

#include <avr/pgmspace.h>

#ifdef NETCONSOLE
/* These need to be exported so the network code sees them.
 * Should NOT be used (except in the network code). */
#define CONSOLE_OPBNETSIZE 250
extern uint8_t console_opbufnet[CONSOLE_OPBNETSIZE];
extern uint16_t console_opbnetpos;
#endif /* NETCONSOLE */

/* Init needs to be called with IRQs still disabled! */
void console_init(void);

/* This should NOT be called usually, it is exported for network console
 * functionality! Needs to be called with IRQs disabled! */
void console_inputchar(uint8_t inpb);

/* These need to be called with IRQs disabled! They are usually NOT what
 * you want. */
void console_printchar_noirq(uint8_t c);
void console_printtext_noirq(const uint8_t * what);
void console_printpgm_noirq_P(PGM_P what);
void console_printhex8_noirq(uint8_t what);
void console_printdec_noirq(uint8_t what);

/* These can be called with interrupts enabled (and will reenable them!) */
void console_printtext(const uint8_t * what);
void console_printpgm_P(PGM_P what);
void console_printhex8(uint8_t what);
void console_printdec(uint8_t what);

#endif /* _CONSOLE_H_ */
