/* $Id: network.h,v 1.5 2012-03-04 22:45:28 simimeie Exp $
 * Network functions
 */

#ifndef _NETWORK_H_
#define _NETWORK_H_

/* *****************************
 * globally exported variables *
 ***************************** */

/* MAC address */
extern uint8_t net_mac[6];

/* Full Duplex enabled */
extern uint8_t net_fdx;

/* IPv4 address */
extern uint8_t net_ip4[4];

/* Global IPv6 address */
extern uint8_t net_ip6[16];

/* IPv6 addressing mode. See eepromdata.h for the meaning of the values. */
extern uint8_t net_ipv6addrmode;

/* Remote CONtrol password */
extern uint8_t net_rconpass[16];


/* *****************************
 * globally exported functions *
 ***************************** */

void enc28j60_init(void);

/* only temporarily exported? for console */
uint8_t enc28j60_readregister(uint8_t ad);

/* checks for incoming packets, sends replies, etc.pp. */
void net_worker(void);

/* shows active connections to the console. called from there
 * WITH INTERRUPTS DISABLED! */
void net_showconnections(void);

#endif /* _NETWORK_H_ */
